//
// Created by zhengwei.
//
/*
标题：包子凑数

小明几乎每天早晨都会在一家包子铺吃早餐。他发现这家包子铺有N种蒸笼，其中第i种蒸笼恰好能放Ai个包子。
 每种蒸笼都有非常多笼，可以认为是无限笼。

每当有顾客想买X个包子，卖包子的大叔就会迅速选出若干笼包子来，使得这若干笼中恰好一共有X个包子。
 比如一共有3种蒸笼，分别能放3、4和5个包子。
 当顾客想买11个包子时，大叔就会选2笼3个的再加1笼5个的（也可能选出1笼3个的再加2笼4个的）。

当然有时包子大叔无论如何也凑不出顾客想买的数量。比如一共有3种蒸笼，分别能放4、5和6个包子。
 而顾客想买7个包子时，大叔就凑不出来了。

小明想知道一共有多少种数目是包子大叔凑不出来的。

输入
----
第一行包含一个整数N。(1 <= N <= 100)
以下N行每行包含一个整数Ai。(1 <= Ai <= 100)

输出
----
一个整数代表答案。如果凑不出的数目有无限多个，输出INF。

例如，
输入：
2
4
5

程序应该输出：
6

再例如，
输入：
2
4
6

程序应该输出：
INF

样例解释：
对于样例1，凑不出的数目包括：1, 2, 3, 6, 7, 11。
对于样例2，所有奇数都凑不出来，所以有无限多个。

资源约定：
峰值内存消耗（含虚拟机） < 256M
CPU消耗  < 1000ms


请严格按要求输出，不要画蛇添足地打印类似：“请您输入...” 的多余内容。

注意：
main函数需要返回0;
只使用ANSI C/ANSI C++ 标准;
不要调用依赖于编译环境或操作系统的特殊函数。
所有依赖的函数必须明确地在源文件中 #include <xxx>
不能通过工程设置而省略常用头文件。

提交程序时，注意选择所期望的语言类型和编译器类型。


*/
#include <stdio.h>
#include <iostream>

using namespace std;
int n, g;
int a[101];
bool f[10000];

int gcd(int a, int b) {
    if (b == 0)return a;
    return gcd(b, a % b);
}

int main(int argc, const char *argv[]) {
    scanf("%d", &n);
    f[0] = true;
    for (int i = 1; i <= n; ++i) {
        scanf("%d", &a[i]);

        if (i == 1)g = a[i];//初始化最大公约数
        else g = gcd(a[i], g);

        for (int j = 0; j < 10000; ++j) {
            if (f[j])f[j + a[i]] = true;
        }
    }

    if (g != 1) {
        printf("INF\n");
        return 0;
    }
    //统计个数
    int ans = 0;
    for (int i = 0; i < 10000; ++i) {
        if (!f[i]) {
            ans++;
//            cout << i << endl;
        }
    }
    printf("%d\n", ans);
    return 0;
}